start	BSR	startup		;Display text and input options
	CMP.B	#'3',option	;Was option 3?
	BEQ	end		;Yes - Exit program
* First read sector 0
	MOVE.W	#2,D0		;Read
	MOVE.W	#0,D1		;Sector 0
	MOVE.W	#1,D2		;1 Sector
	BSR	sectorio	;Do sector I-O
* Now change to our format
	LEA	buff(PC),A0	;Get address of buffer in A0
	MOVE.W	#$0300,$16(A0)	;3 secotrs/FAT
	MOVE.B	#$30,$11(A0)	;48 Directory entries(=3 Sectors)
*
	MOVE.W	#-1,-(SP)	;Don't change executability
	MOVE.W	#3,-(SP)	;Double sided 80 track
	MOVE.W	#-1,-(SP)	;Don't change serial No.
	PEA	buff(PC)
	MOVE.W	#18,-(SP)	
	TRAP	#14
	LEA	14(SP),SP
* Re-write sector 0
	MOVE.W	#3,D0		;Write
	MOVE.W	#0,D1		;Sector 0
	MOVE.W	#1,D2		;1 Sector
	BSR 	sectorio	;Do sector I-O
	TST.W	D0		;Check is was O.K.
	BPL	.ok		;Yes it was.
	PEA	write_error(PC)	;No it wasn't - display error message
	MOVE.W	#9,-(SP)
	TRAP	#1
	ADDQ.L	#6,SP
* Press any key ....
	MOVE.W	#1,-(SP)
	TRAP	#1
	ADDQ.L	#2,SP
	BRA	end		;Exit program
.ok
* Calculate the number of clusters to protect.
	LEA	buff(PC),A0	;A0 points to buffer holding sector 0
	CLR.W	D0
	MOVE.B	20(A0),D0	;D0.W = No. of Sectors on disk HI byte.
	LSL.W	#8,D0		;Put hi byte in hi byte of D0
	MOVE.B	19(A0),D0	;Put low byte No. of Sectors in D0.
	SUB.W	#10,D0		;Take 10 off for 1st track.
	LSR.W	#1,D0		;Divide by 2 for cluster count.
	MOVE.W	D0,no_of_clusters
*
*
* Now 'pretend' all the side 2 sectors are 'bad'
* (or not, depending on option).
*
* First read FAT tables into memory (two lots of three sectors)
*
	MOVE.W	#2,D0		;Read
	MOVE.W	#1,D1		;Sector 1
	MOVE.W	#6,D2		;6 Sectors
	BSR	sectorio	;Do sector I-O
*
	MOVE.W	#2,D7		;Start at Cluster 2.
	LEA	buff(PC),A0	;Address of buffer in A0
	MOVE.W	no_of_clusters,D4
.lp0	MOVE.W	#4,D6		;5 clusters to change(1 sector)
.lp1	MOVE.W	D7,D0		;Set cluster No.
	ADD.W	D6,D0
	CLR.W	D1		;0 in cluster = unused.
	CMP.B	#'1',option	;Option 1 (protect) ?
	BNE.S	.opt2
	MOVE.W	#$FF7,D1	;$FF7 in cluster = protected.
.opt2	BSR	write_to_FAT	;Write this FAT entry.
	DBF.W	D6,.lp1		;Do next cluster in sector
	ADD.W	#10,D7		;Do next sector.
	CMP.W	D4,D7		;Done whole disk?
	BLT	.lp0		;Not yet...
*
* Now copy 1st FAT to copy
	LEA	buff(PC),A0	;Buffer address in A0
	MOVE.L	A0,A1		;Copy of A0 in A1
	ADD.L	#512*3,A1	;Add '3 sectors' to A1
	MOVE.L	#((512*3)/4)-1,D0	;D0 is count of Longwords to move
.lp	MOVE.L	(A0)+,(A1)+	;Move the FAT table
	DBF	D0,.lp		;to the copy.
*
* Finally, write the info to the disk...
	MOVE.W	#3,D0		;Write
	MOVE.W	#1,D1		;Sector 1
	MOVE.W	#6,D2		;6 Sectors
	BSR	sectorio	;Do sector I-O.
*
end	CLR.W	-(SP)		;Finito - back to
	TRAP	#1		;the desktop.
	
	
**********************************************
* D0 = (2-read, 3-write)		     *
* D1 = Start sector			     *
* D2 = No. of sectors			     *
**********************************************
sectorio			;Do sector i-o.
	MOVE.W	drive,-(SP)	;Drive No.
	MOVE.W	D1,-(SP)	;Sector no.
	MOVE.W	D2,-(SP)	;No. of Sectors
	PEA	buff(PC)	;Into/out of buff
	MOVE.W	D0,-(SP)	;read or write
	MOVE.W	#4,-(SP)
	TRAP	#13
	LEA	14(SP),SP
	RTS
	
write_to_FAT
	MOVEM.L	D0-D7/A0-A6,-(SP)	;Save the registers
	LEA	buff(PC),A0		;Addr of buffer holding FAT table.
*
	MOVE.W	D0,D4		;Cluster No. copied to D4.
	LSR.W	#1,D4		;D4 = cluster / 2
	ADD.W	D0,D4		;D4 = cluster * 1.5.
	BTST	#0,D0		;Odd or even address?
	BEQ	.even
.odd	MOVE.W	D1,D3
	LSR.W	#4,D3		;D3 = high two nybbles.
	MOVE.B	D3,1(A0,D4.W)	;Move into table
	AND.B	#$F,0(A0,D4.W)	;Mask one nybble out of table
	LSL.W	#4,D1		;D1.B holds low nybble
	OR.B	D1,0(A0,D4.W)	;'OR' it onto table.
	BRA.S	.exit
*
.even	MOVE.B	D1,0(A0,D4.W)	;Low byte goes in.
	LSR.W	#8,D1		;Get high nybble in D1.B
	AND.B	#$F,D1		;Mask off nybble in D1
	AND.B	#$F0,1(A0,D4.W)	;Mask off nybble in table
	OR.B	D1,1(A0,D4.W)	;'OR' into table
*
.exit	MOVEM.L	(SP)+,D0-D7/A0-A6	;Restore registers.
	RTS
*********************************
startup
*
.drv	PEA	menu_txt(PC)	;Display menu options.
	MOVE.W	#9,-(SP)
	TRAP	#1
	ADDQ.L	#6,SP
* Select drive letter ...
	MOVE.W	#1,-(SP)
	TRAP	#1
	ADDQ.L	#2,SP
*
	AND.W	#%11011111,D0	;Force to UPPER case.
*
	MOVE.W	D0,drive	;Store drive.
*	
	SUB.W	#65,drive
	BMI	.drv
	CMP.W	#1,drive
	BGT	.drv
*
.opt	PEA	menu1_txt(PC)
	MOVE.W	#9,-(SP)
	TRAP	#1
	ADDQ.L	#6,SP
	
* Select option (1,2 or 3).
	MOVE.W	#1,-(SP)
	TRAP	#1
	ADDQ.L	#2,SP
*
	CMP.B	#'1',D0
	BLT	.opt
	CMP.B	#'3',D0
	BGT	.opt
	MOVE.B	D0,option
*
	PEA	wait_txt(PC)
	MOVE.W	#9,-(SP)
	TRAP	#1
	ADDQ.L	#6,SP
*
.exit
*
	RTS
***********************************
     section	DATA
	EVEN
menu_txt
	DC.B	27,'b2',27,'c3'
	DC.B	27,'E',27,'e'
	DC.B	27,'Y',32+0,32+20
	DC.B	'The double-single sided disk fiddler'
	DC.B	27,'Y',32+3,32+15	
	DC.B	'Which Disk Drive do you wish to use (A or B) : ',0
	EVEN
menu1_txt
	DC.B	27,'Y',32+7,32+25
	DC.B	'PROTECT SIDE 2 ..............1.'
	DC.B	27,'Y',32+9,32+25
	DC.B	'UNPROTECT SIDE 2 ............2.'
	DC.B	27,'Y',32+11,32+25
	DC.B	'CANCEL ......................3.'
	DC.B	27,'Y',32+14,32+25
	DC.B	'Please select an Option .. ',0
	EVEN
wait_txt
	DC.B	27,'Y',32+18,32+30
	DC.B	'PLEASE WAIT - PROCESSING'
	DC.B	27,'f',0
	EVEN
write_error
	DC.B	27,'b0',27,'c1'
	DC.B	27,'E'
	DC.B	27,'v'
	DC.B	27,'Y',32+5,32+2
	DC.B	'DISK ERROR - Press a Key to Exit!',0
	EVEN
       section	BSS
*
drive	DS.W	1
option	DS.B	1
	EVEN
no_of_clusters
	DS.W	1
buff	DS.B	512*10
